/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 79 "cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;
static struct script_route_ref *rt_ref = NULL;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 217 "cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CFG_TAB_H_INCLUDED
# define YY_YY_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DROP = 258,
    ASSERT = 259,
    EXIT = 260,
    RETURN = 261,
    LOG_TOK = 262,
    ERROR = 263,
    ROUTE = 264,
    ROUTE_FAILURE = 265,
    ROUTE_ONREPLY = 266,
    ROUTE_BRANCH = 267,
    ROUTE_ERROR = 268,
    ROUTE_LOCAL = 269,
    ROUTE_STARTUP = 270,
    ROUTE_TIMER = 271,
    ROUTE_EVENT = 272,
    IF = 273,
    ELSE = 274,
    SWITCH = 275,
    CASE = 276,
    DEFAULT = 277,
    BREAK = 278,
    WHILE = 279,
    FOR = 280,
    IN = 281,
    READONLY = 282,
    EXPIRE = 283,
    NULLV = 284,
    XDBG = 285,
    XLOG = 286,
    XLOG_BUF_SIZE = 287,
    XLOG_FORCE_COLOR = 288,
    XLOG_PRINT_LEVEL = 289,
    XLOG_LEVEL = 290,
    PV_PRINT_BUF_SIZE = 291,
    DEBUG_MODE = 292,
    ENABLE_ASSERTS = 293,
    ABORT_ON_ASSERT = 294,
    LOGLEVEL = 295,
    LOGPREFIX = 296,
    LOGSTDOUT = 297,
    LOGSTDERROR = 298,
    STDERROR_ENABLED = 299,
    SYSLOG_ENABLED = 300,
    LOG_EVENT_ENABLED = 301,
    STDERROR_LEVEL_FILTER = 302,
    SYSLOG_LEVEL_FILTER = 303,
    LOG_EVENT_LEVEL_FILTER = 304,
    STDERROR_FORMAT = 305,
    SYSLOG_FORMAT = 306,
    LOG_JSON_BUF_SIZE = 307,
    LOG_MSG_BUF_SIZE = 308,
    LOGFACILITY = 309,
    SYSLOG_FACILITY = 310,
    LOGNAME = 311,
    SYSLOG_NAME = 312,
    AVP_ALIASES = 313,
    LISTEN = 314,
    SOCKET = 315,
    MEMGROUP = 316,
    ALIAS = 317,
    AUTO_ALIASES = 318,
    TAG = 319,
    DNS = 320,
    REV_DNS = 321,
    DNS_TRY_IPV6 = 322,
    DNS_TRY_NAPTR = 323,
    DNS_RETR_TIME = 324,
    DNS_RETR_NO = 325,
    DNS_SERVERS_NO = 326,
    DNS_USE_SEARCH = 327,
    MAX_WHILE_LOOPS = 328,
    UDP_WORKERS = 329,
    CHECK_VIA = 330,
    SHM_HASH_SPLIT_PERCENTAGE = 331,
    SHM_SECONDARY_HASH_SIZE = 332,
    MEM_WARMING_ENABLED = 333,
    MEM_WARMING_PATTERN_FILE = 334,
    MEM_WARMING_PERCENTAGE = 335,
    RPM_MEM_FILE = 336,
    RPM_MEM_SIZE = 337,
    MEMLOG = 338,
    MEMDUMP = 339,
    SHM_MEMLOG_SIZE = 340,
    EXECMSGTHRESHOLD = 341,
    EXECDNSTHRESHOLD = 342,
    TCPTHRESHOLD = 343,
    EVENT_SHM_THRESHOLD = 344,
    EVENT_PKG_THRESHOLD = 345,
    QUERYBUFFERSIZE = 346,
    QUERYFLUSHTIME = 347,
    SIP_WARNING = 348,
    SERVER_SIGNATURE = 349,
    SERVER_HEADER = 350,
    USER_AGENT_HEADER = 351,
    LOADMODULE = 352,
    MPATH = 353,
    MODPARAM = 354,
    MAXBUFFER = 355,
    CHROOT = 356,
    WDIR = 357,
    MHOMED = 358,
    POLL_METHOD = 359,
    TCP_ACCEPT_ALIASES = 360,
    TCP_WORKERS = 361,
    TCP_CONNECT_TIMEOUT = 362,
    TCP_CON_LIFETIME = 363,
    TCP_SOCKET_BACKLOG = 364,
    TCP_MAX_CONNECTIONS = 365,
    TCP_NO_NEW_CONN_BFLAG = 366,
    TCP_NO_NEW_CONN_RPLFLAG = 367,
    TCP_KEEPALIVE = 368,
    TCP_KEEPCOUNT = 369,
    TCP_KEEPIDLE = 370,
    TCP_KEEPINTERVAL = 371,
    TCP_MAX_MSG_TIME = 372,
    TCP_PARALLEL_READ_ON_WORKERS = 373,
    ADVERTISED_ADDRESS = 374,
    ADVERTISED_PORT = 375,
    DISABLE_CORE = 376,
    OPEN_FD_LIMIT = 377,
    MCAST_LOOPBACK = 378,
    MCAST_TTL = 379,
    TOS = 380,
    DISABLE_DNS_FAILOVER = 381,
    DISABLE_DNS_BLACKLIST = 382,
    DST_BLACKLIST = 383,
    DISABLE_STATELESS_FWD = 384,
    DB_VERSION_TABLE = 385,
    DB_DEFAULT_URL = 386,
    DB_MAX_ASYNC_CONNECTIONS = 387,
    DISABLE_503_TRANSLATION = 388,
    SYNC_TOKEN = 389,
    ASYNC_TOKEN = 390,
    LAUNCH_TOKEN = 391,
    AUTO_SCALING_PROFILE = 392,
    AUTO_SCALING_CYCLE = 393,
    TIMER_WORKERS = 394,
    EQUAL = 395,
    EQUAL_T = 396,
    GT = 397,
    LT = 398,
    GTE = 399,
    LTE = 400,
    DIFF = 401,
    MATCH = 402,
    NOTMATCH = 403,
    COLONEQ = 404,
    PLUSEQ = 405,
    MINUSEQ = 406,
    SLASHEQ = 407,
    MULTEQ = 408,
    MODULOEQ = 409,
    BANDEQ = 410,
    BOREQ = 411,
    BXOREQ = 412,
    OR = 413,
    AND = 414,
    BOR = 415,
    BAND = 416,
    BXOR = 417,
    BLSHIFT = 418,
    BRSHIFT = 419,
    PLUS = 420,
    MINUS = 421,
    SLASH = 422,
    MULT = 423,
    MODULO = 424,
    NOT = 425,
    BNOT = 426,
    RPAREN = 427,
    NUMBER = 428,
    ZERO = 429,
    ID = 430,
    STRING = 431,
    SCRIPTVAR = 432,
    IPV6ADDR = 433,
    IPV4ADDR = 434,
    IPNET = 435,
    COMMA = 436,
    SEMICOLON = 437,
    LPAREN = 438,
    LBRACE = 439,
    RBRACE = 440,
    LBRACK = 441,
    RBRACK = 442,
    AS = 443,
    USE_WORKERS = 444,
    USE_AUTO_SCALING_PROFILE = 445,
    MAX = 446,
    MIN = 447,
    DOT = 448,
    CR = 449,
    COLON = 450,
    ANY = 451,
    ANYCAST = 452,
    FRAG = 453,
    REUSE_PORT = 454,
    SCRIPTVARERR = 455,
    SCALE_UP_TO = 456,
    SCALE_DOWN_TO = 457,
    ON = 458,
    CYCLES = 459,
    CYCLES_WITHIN = 460,
    PERCENTAGE = 461
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 231 "cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct listen_param* listen_param;
	struct _pv_spec *specval;
	struct multi_str* multistr;

#line 478 "cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 495 "cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  234
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2380

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  207
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  519
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  990

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   461

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   500,   500,   503,   504,   505,   508,   509,   510,   510,
     511,   511,   512,   512,   513,   513,   514,   514,   515,   515,
     516,   516,   517,   517,   518,   518,   520,   523,   538,   547,
     562,   563,   566,   567,   581,   586,   596,   597,   600,   601,
     602,   606,   608,   610,   615,   621,   623,   627,   629,   631,
     633,   637,   640,   641,   644,   646,   648,   654,   657,   660,
     663,   666,   669,   672,   677,   678,   681,   682,   683,   683,
     688,   688,   695,   696,   698,   699,   702,   710,   719,   725,
     732,   738,   745,   751,   758,   764,   771,   777,   786,   787,
     788,   791,   792,   793,   796,   797,   800,   801,   802,   806,
     814,   822,   828,   836,   840,   852,   853,   854,   855,   856,
     857,   872,   874,   877,   878,   899,   900,   911,   912,   923,
     924,   933,   934,   940,   941,   947,   948,   950,   951,   976,
    1001,  1009,  1010,  1018,  1019,  1026,  1027,  1033,  1034,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1065,  1066,  1069,  1073,  1074,  1075,
    1083,  1091,  1099,  1107,  1115,  1123,  1131,  1139,  1147,  1155,
    1158,  1159,  1162,  1163,  1164,  1165,  1166,  1167,  1168,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1185,  1186,  1200,  1201,
    1202,  1203,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,
    1212,  1213,  1214,  1215,  1225,  1235,  1236,  1241,  1242,  1245,
    1249,  1250,  1255,  1256,  1259,  1260,  1263,  1264,  1267,  1268,
    1275,  1276,  1283,  1285,  1288,  1289,  1292,  1293,  1296,  1299,
    1306,  1307,  1314,  1315,  1322,  1323,  1325,  1326,  1330,  1331,
    1334,  1335,  1337,  1338,  1340,  1342,  1344,  1345,  1346,  1347,
    1349,  1350,  1357,  1360,  1368,  1371,  1415,  1416,  1421,  1423,
    1425,  1426,  1432,  1434,  1448,  1450,  1453,  1454,  1457,  1458,
    1465,  1466,  1473,  1474,  1478,  1506,  1507,  1509,  1510,  1513,
    1514,  1517,  1518,  1528,  1538,  1540,  1542,  1543,  1545,  1546,
    1548,  1551,  1553,  1556,  1557,  1560,  1562,  1565,  1568,  1572,
    1573,  1579,  1585,  1591,  1595,  1596,  1599,  1615,  1631,  1632,
    1635,  1641,  1651,  1661,  1672,  1675,  1684,  1689,  1712,  1717,
    1725,  1741,  1744,  1750,  1753,  1761,  1767,  1770,  1776,  1779,
    1787,  1790,  1798,  1801,  1809,  1812,  1825,  1828,  1834,  1839,
    1840,  1841,  1842,  1843,  1844,  1847,  1848,  1851,  1852,  1853,
    1854,  1856,  1857,  1860,  1861,  1864,  1865,  1866,  1869,  1885,
    1890,  1891,  1892,  1894,  1899,  1902,  1905,  1908,  1911,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1930,
    1931,  1932,  1933,  1934,  1935,  1938,  1941,  1944,  1947,  1950,
    1953,  1956,  1959,  1962,  1965,  1968,  1971,  1984,  1997,  2012,
    2013,  2014,  2015,  2016,  2019,  2020,  2021,  2024,  2025,  2026,
    2029,  2030,  2031,  2035,  2036,  2037,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2061,  2069,  2079,  2087,  2097,  2105,  2123,
    2132,  2133,  2135,  2136,  2139,  2145,  2151,  2157,  2165,  2168,
    2171,  2176,  2186,  2193,  2200,  2210,  2215,  2222,  2232,  2237,
    2244,  2256,  2261,  2266,  2271,  2276,  2286,  2296,  2306,  2318,
    2336,  2367,  2371,  2377,  2380,  2381,  2382,  2383,  2384,  2386,
    2388,  2390,  2392,  2394,  2395,  2398,  2404,  2405,  2407,  2413,
    2414,  2416,  2420,  2439,  2440,  2442,  2465,  2501,  2503,  2506,
    2508,  2510,  2512,  2514,  2516,  2518,  2525,  2532,  2539,  2546
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DROP", "ASSERT", "EXIT", "RETURN",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE", "ROUTE_ONREPLY",
  "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL", "ROUTE_STARTUP",
  "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT",
  "BREAK", "WHILE", "FOR", "IN", "READONLY", "EXPIRE", "NULLV", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL",
  "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS",
  "ABORT_ON_ASSERT", "LOGLEVEL", "LOGPREFIX", "LOGSTDOUT", "LOGSTDERROR",
  "STDERROR_ENABLED", "SYSLOG_ENABLED", "LOG_EVENT_ENABLED",
  "STDERROR_LEVEL_FILTER", "SYSLOG_LEVEL_FILTER", "LOG_EVENT_LEVEL_FILTER",
  "STDERROR_FORMAT", "SYSLOG_FORMAT", "LOG_JSON_BUF_SIZE",
  "LOG_MSG_BUF_SIZE", "LOGFACILITY", "SYSLOG_FACILITY", "LOGNAME",
  "SYSLOG_NAME", "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP", "ALIAS",
  "AUTO_ALIASES", "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "SHM_MEMLOG_SIZE", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD",
  "TCPTHRESHOLD", "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD",
  "QUERYBUFFERSIZE", "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM",
  "MAXBUFFER", "CHROOT", "WDIR", "MHOMED", "POLL_METHOD",
  "TCP_ACCEPT_ALIASES", "TCP_WORKERS", "TCP_CONNECT_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "TCP_PARALLEL_READ_ON_WORKERS", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "DISABLE_DNS_FAILOVER", "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST",
  "DISABLE_STATELESS_FWD", "DB_VERSION_TABLE", "DB_DEFAULT_URL",
  "DB_MAX_ASYNC_CONNECTIONS", "DISABLE_503_TRANSLATION", "SYNC_TOKEN",
  "ASYNC_TOKEN", "LAUNCH_TOKEN", "AUTO_SCALING_PROFILE",
  "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL", "EQUAL_T", "GT", "LT",
  "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH", "COLONEQ", "PLUSEQ",
  "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ",
  "OR", "AND", "BOR", "BAND", "BXOR", "BLSHIFT", "BRSHIFT", "PLUS",
  "MINUS", "SLASH", "MULT", "MODULO", "NOT", "BNOT", "RPAREN", "NUMBER",
  "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR", "IPNET",
  "COMMA", "SEMICOLON", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK",
  "AS", "USE_WORKERS", "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT",
  "CR", "COLON", "ANY", "ANYCAST", "FRAG", "REUSE_PORT", "SCRIPTVARERR",
  "SCALE_UP_TO", "SCALE_DOWN_TO", "ON", "CYCLES", "CYCLES_WITHIN",
  "PERCENTAGE", "$accept", "cfg", "statements", "statement", "$@1", "$@2",
  "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "listen_id", "host_sep",
  "host", "proto", "port", "snumber", "phostport", "panyhostport",
  "alias_def", "id_lst", "listen_id_def", "socket_def_param",
  "socket_def_params", "socket_def", "$@10", "$@11", "any_proto",
  "multi_string", "blst_elem", "blst_def", "blst_flag", "blst_flags",
  "blst_elem_list", "auto_scale_profile_def", "assign_stm", "module_stm",
  "ip", "ipv4", "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name",
  "route_name_var", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "assignop", "assignexp", "assign_cmd", "exp_stm",
  "brk_stm", "stm", "actions", "brk_actions", "action", "brk_action",
  "brk_if_cmd", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm", "func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461
};
# endif

#define YYPACT_NINF -864

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-864)))

#define YYTABLE_NINF -459

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2186,   -91,   -49,   -35,   -24,    14,    31,   213,   223,   230,
     242,   275,   308,   326,   345,   370,   410,   441,   451,   467,
     473,   476,   479,   484,   496,   500,   507,   520,   535,   560,
     565,   572,   593,   596,   598,   344,   356,   361,   366,   367,
     390,   619,   620,   622,   629,   635,   640,   642,   656,   662,
     673,   684,   687,   691,   695,   701,   709,   715,   718,   719,
     725,   727,   735,   742,   746,    37,   753,    24,   757,   760,
     770,   779,   788,   789,   792,   793,   794,   796,   804,   805,
     809,   811,   813,   820,   826,   829,   830,   832,   834,   842,
     848,   849,   853,   858,   391,   428,   859,   873,   874,   879,
     880,   882,   889,   891,   897,  -864,   119,  2023,  -864,   157,
     276,   431,   582,   564,   465,   580,   584,   613,  -864,  -864,
    -864,    96,   130,   196,   193,   201,   208,   350,   354,   655,
      62,   364,   378,   379,   399,   419,   359,   363,   383,   525,
     552,   420,   423,    84,   107,    95,    98,   146,   149,   669,
      54,   424,   425,   435,  -864,   599,  -864,   678,  -864,   866,
    -864,   868,  -864,   871,  -864,   872,   436,   437,   450,   453,
     454,   455,   102,   456,   113,   458,   388,   449,   452,   459,
     460,   462,   464,   466,   468,   469,   470,   471,   117,   121,
    -864,  -864,   124,  -864,   722,   475,    92,   105,   477,   126,
     486,   489,   490,   491,   492,   501,   148,   151,   503,   504,
     508,   517,   518,   521,   120,   554,   556,   557,   558,   559,
     162,  -864,   875,  -864,   886,   863,   894,   128,   129,   561,
     566,   154,   570,   901,  -864,   -91,  -864,     6,  -864,     7,
    -864,    50,  -864,    26,  -864,    20,  -864,    44,  -864,    57,
    -864,    45,  -864,    49,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,   903,   907,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,   966,  -864,
     810,   758,   827,  -864,  -864,  -864,   851,  -864,   867,  -864,
    -864,  -864,   905,   899,  -864,   -56,   904,  -864,   885,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,   908,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,   912,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,   914,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,   -97,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,   883,  -864,  -864,
    -864,   915,  -864,  1845,   705,  -864,   705,  -864,  1845,   705,
    -864,   705,  -864,  1845,  -864,  1845,  -864,  1845,  -864,   705,
    -864,   705,  -864,  -864,  -864,   965,   898,   898,   131,   902,
     995,  -864,   163,   931,   995,  -864,   935,   936,   938,   835,
     930,  -864,   942,   943,   937,   948,   949,   588,    32,    56,
      74,   952,   953,   954,   959,   962,   963,   967,   969,    75,
    -864,  -864,  -864,  1269,   971,   786,  -864,  -864,  -864,  -864,
    -864,    67,  -864,  -864,  -864,   961,   968,   865,   982,   988,
     900,   934,   972,   975,   989,   922,   984,   983,   995,  1004,
    1007,  -864,  -864,  -864,   898,  -864,  -864,  -864,  1020,  -864,
    -864,  1005,  -864,  -864,  -864,  1026,  -864,  -864,  -864,  -864,
    -864,  -107,   528,   998,  -864,  1036,  1446,  1037,   -31,  -864,
    -864,  -864,   144,  -864,   132,  -864,    10,  1446,  -138,  1446,
    -138,  1038,  1039,  1049,  1049,  -864,   111,  1183,  1184,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -864,  1558,  -864,  -864,
    -864,  -864,  -864,  -864,  1042,  1043,  -864,  1044,  1045,  -864,
    -864,  -864,  1058,  1057,   -73,     2,  -864,  1047,  -864,  -864,
    -864,  -864,  -864,     5,   579,   835,  -864,  1019,  -864,   571,
    -864,  -864,    15,  -864,  -864,  1070,  -864,  1446,  1446,  1630,
    1558,  -864,   534,  1522,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  1072,  1073,  1074,  1075,  1069,  1080,  1076,  1081,
    -864,   -68,  -864,    -2,  1082,     0,  1232,   -52,   -36,   592,
     -11,    77,  1078,   -28,  1088,  -864,  -864,   711,  -864,  -864,
     -21,  -864,  -864,  1558,  -864,  1558,  -864,  1131,  -864,  1439,
    -864,  1845,  1845,  1845,  1845,  1077,  1845,  -864,  -864,  -864,
    -864,  -864,    41,  -864,  -864,    27,  1109,   241,  -864,   571,
    -864,  -864,  -864,  1102,   222,  -864,   664,  -864,  1115,  -864,
     322,  -864,  1003,   999,  1446,  1446,  1112,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,   660,   -38,  -864,   655,   519,
    -864,  -864,  -864,  -864,  1113,  -864,  1114,  -864,  -864,   632,
    1765,  1101,  1507,  -138,  -864,  -864,  -864,  -864,  -864,  1119,
    -864,  -864,   246,   705,  -864,   705,  -864,  -864,  -864,  -864,
    -864,   818,  -864,  1319,  1558,  1558,  1558,  1558,  1558,  1558,
    1558,  1558,  1558,  1558,  1048,  1186,  1231,  1262,  1107,  1293,
    -864,  -864,  -864,  -864,  -864,  1122,   258,   621,  -864,   -73,
    -864,  1279,  -864,  -864,  -864,  -864,  -864,  1133,  -864,  -864,
    -864,  -864,  -864,  1134,  1135,  -864,  -864,  -864,  -864,   259,
    1773,  1289,  -864,  1288,  1127,  1130,  -864,  1567,  1132,  -864,
    -864,  -864,  -864,  -864,  -864,    81,  1143,   323,   336,  1144,
    -864,   302,   305,   397,  -864,  -864,  -864,  -864,  1053,  1053,
    1053,  1053,  1053,  -864,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  1845,  -864,   621,  -864,   -73,   398,  1147,  1153,
    -864,  -864,  -864,  -864,   750,  -864,  1324,  1765,   653,  1149,
     493,  -864,  1446,  -864,  -864,   679,  -864,  -864,  -864,  -864,
    1507,  -864,  -864,  -864,  -864,  -864,  1162,  -864,  1160,  1369,
     604,  1148,  -864,   -73,  -864,  -133,  -864,  -864,  -864,  -864,
    -864,  -864,  1142,  1145,  -864,  1146,  -864,  -864,   339,  -864,
    -864,  -864,  -864,  1166,  1167,  -864,  -864,   -73,  -864,   605,
    1141,  1172,  1816,  1816,  1816,  1507,  -864,  -864,   631,  -864,
    1170,  1174,  1150,   581,   648,   717,  1331,  -864,  1175,  1181,
    1154,  1185,  1507,  1187,  -864,  1189,  1157,  -864,  -864,  1195,
    1192,  1344,  1210,  1207,  1356,  1152,  1209,  -864,  1179,  -864
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     6,     7,
     307,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   147,     0,   149,     0,   151,     0,
     153,     0,   155,     0,   157,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     309,   308,     0,   313,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   289,     0,   291,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     5,     3,     0,     9,     0,
      11,     0,    13,     0,    15,     0,    17,     0,    19,     0,
      21,     0,    23,     0,    25,   256,   253,   257,   254,   258,
     255,   260,     0,     0,    38,   259,   252,   251,   111,   110,
     107,   106,   109,   108,   103,   105,   104,   113,   112,   115,
     114,   117,   116,   119,   118,   121,   120,   123,   122,   125,
     124,   127,   126,   128,   129,   131,   130,   133,   132,   135,
     134,   137,   136,   139,   138,   141,   140,   264,     0,    35,
       0,    67,    66,   263,   262,   261,     0,   268,    32,    28,
     317,   316,     0,     0,    47,    29,     0,    51,    52,   267,
      27,   314,   318,   315,   270,   269,   143,   142,   145,   144,
     146,   148,   150,   152,   154,   156,   159,   158,   164,   162,
     168,   167,   170,   169,   172,   171,   174,   173,   176,   175,
     178,   177,   180,   179,   182,   181,   184,   183,   188,   187,
     186,   185,   190,   189,   192,   191,   194,   193,   196,   195,
     198,   197,   200,   199,   202,   201,   204,   203,   246,   245,
     248,   247,   250,   249,   287,   286,     0,   161,   160,   207,
     206,   205,   210,   209,   208,   212,   211,   215,   213,   214,
     217,   216,   220,   218,   222,   221,   224,   223,   226,   225,
     228,   227,   230,   229,   232,   231,   234,   233,   240,   239,
     242,   241,   244,   243,   236,   235,   238,   237,   272,    32,
     271,   274,   273,   276,   275,   278,   277,   280,   279,   282,
     281,   285,   283,   284,   288,   290,    90,   294,   296,   295,
     298,   297,   300,   299,   302,   301,   304,     0,   303,   306,
     305,   165,   331,     0,     0,   333,     0,   336,     0,     0,
     338,     0,   340,     0,   342,     0,   344,     0,   346,     0,
     348,     0,    39,    40,    44,     0,     0,     0,     0,     0,
       0,    31,     0,     0,     0,    53,     0,     0,     0,     0,
       0,   293,     0,     0,   484,     0,   486,   493,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     368,   432,   369,     0,     0,     0,   421,   427,   428,   429,
     430,     0,   325,   324,   326,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    41,     0,     0,     0,
       0,    57,    58,    59,    64,    71,    69,   266,    74,   265,
     319,    48,    34,    33,   163,     0,   219,    93,    91,    92,
      95,    90,     0,     0,   166,     0,     0,     0,     0,   490,
     488,   496,     0,   499,     0,   503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   508,     0,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,     0,   431,   422,
     329,   420,   433,   426,     0,     0,   334,     0,     0,   339,
     341,   343,     0,     0,     0,     0,    62,    54,    61,    60,
      63,    65,    75,     0,     0,     0,   292,     0,   320,     0,
      89,    97,     0,   321,    86,     0,   485,     0,     0,     0,
       0,   372,     0,   373,   354,   370,   411,   371,   410,   409,
     487,   492,     0,     0,     0,     0,     0,     0,     0,     0,
     327,     0,   328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   505,   460,   462,   465,   468,
       0,   407,   408,     0,   390,     0,   389,   391,   392,   406,
     393,     0,     0,     0,     0,     0,     0,    36,    37,    46,
      43,    42,     0,    50,    49,     0,     0,     0,    94,     0,
      87,    72,    73,     0,     0,    98,     0,    88,     0,   351,
       0,   413,     0,     0,     0,     0,     0,   355,   357,   358,
     359,   360,   356,   361,   362,   363,   364,   367,     0,     0,
     491,   489,   497,   494,     0,   500,     0,   504,   501,     0,
       0,     0,     0,     0,   509,   322,   510,   323,   511,     0,
     512,   482,     0,     0,   519,     0,   507,   463,   466,   469,
     506,   464,   404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      56,    55,   310,   312,   311,     0,     0,     0,    84,     0,
      96,     0,   352,   412,   353,   350,   349,     0,   377,   378,
     376,   375,   374,     0,     0,   473,   471,   472,   474,     0,
       0,   445,   417,     0,     0,     0,   441,     0,     0,   447,
     414,   436,   437,   438,   439,     0,     0,     0,     0,     0,
     479,     0,     0,     0,   461,   467,   470,   405,   400,   399,
     401,   402,   403,   394,   395,   397,   396,   398,   330,   332,
     335,   337,     0,   347,     0,    85,     0,     0,     0,     0,
     483,   495,   498,   502,     0,   419,     0,     0,     0,     0,
     451,   453,     0,   434,   416,     0,   424,   440,   442,   435,
       0,   513,   514,   481,   480,   515,     0,   518,     0,     0,
       0,     0,    80,     0,    82,     0,   478,   475,   476,   477,
     418,   446,     0,     0,   449,     0,   452,   450,     0,   425,
     415,   423,   448,     0,     0,   345,    81,     0,    83,     0,
     102,     0,   457,   455,   459,     0,   516,   517,     0,    78,
       0,     0,   101,     0,     0,     0,   443,    79,     0,     0,
       0,     0,     0,     0,    76,     0,     0,   444,    77,     0,
       0,     0,     0,     0,     0,     0,     0,   100,     0,    99
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -864,  -864,  -864,  1277,  -864,  -864,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -210,  -864,  -864,  -149,  -611,  -124,   -66,
    -864,  -864,  1060,  -864,  -864,  -449,  1237,  -864,  -864,   661,
     823,   659,   815,   747,  -864,  -864,  -864,  -864,  -864,  -148,
    -864,  1079,  -864,  -612,  -537,  -412,  -864,  -864,  -864,  -864,
    -864,  -864,  -864,  -864,  -864,  -864,  -571,  -864,  -864,  -864,
    -864,  -864,  -256,  -864,  -568,  -864,   327,  -556,  -864,  -863,
     505,  -468,   -40,  -491,   138,  -864,  -563,  -699,  -520,  -389,
    -864,  -864,   510,  -864,   623,  -864,   799,  -577
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   324,   503,   325,   310,   719,   706,   311,
     312,   328,   329,   638,   564,   565,   313,   497,   496,   733,
     569,   651,   511,   580,   581,   652,   468,   118,   119,   653,
     331,   332,   333,   654,   688,   545,   681,   238,   240,   242,
     244,   246,   248,   250,   252,   254,   662,   755,   756,   757,
     758,   759,   533,   664,   708,   617,   709,   534,   667,   849,
     841,   535,   905,   536,   850,   851,   537,   538,   539,   540,
     899,   900,   901,   937,   700,   839,   692,   541
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     265,   326,   330,   720,   440,   274,   723,   472,   475,   669,
     547,   679,   288,   290,   292,   550,   735,   551,   665,   552,
     669,   482,   669,   668,   721,   193,   683,   480,   685,   665,
     666,   665,   724,   591,   668,   730,   668,   734,   190,   530,
     710,   666,   810,   666,   621,   484,   488,   942,   566,   120,
     490,   477,   367,   369,   371,   317,   621,   593,   486,   621,
     621,   621,   532,   275,   546,   690,   330,   548,   622,   549,
     509,   950,   951,   852,   645,   595,   605,   553,   781,   554,
     669,   669,   908,   710,   327,   299,   739,   740,   510,   665,
     665,   121,   966,   399,   668,   668,   303,   255,   510,   305,
     717,   666,   666,   358,   768,   122,   402,   727,   301,   977,
     501,   811,   694,   769,   362,   641,   123,   816,   390,   234,
     774,   438,   392,   718,   775,   394,   710,   407,   710,   458,
     460,   257,   567,   677,   262,   263,   776,   502,  -366,  -366,
     777,   671,   264,   829,   784,   674,   530,   307,   852,   422,
     314,   790,   424,   785,   124,   466,   744,   745,   744,   745,
     791,   780,  -366,   451,   572,   777,   237,   669,   669,   532,
     770,   125,   772,   825,   826,   717,   665,   665,   717,   326,
     330,   668,   668,   542,   680,   543,   544,   530,   666,   666,
     473,   742,   474,   476,   261,   855,   736,   259,   718,   812,
     737,   718,   266,   775,   483,   887,   852,   194,   888,   268,
     532,   852,   481,   191,   717,   592,   848,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   308,   485,   318,
     319,   489,   320,   321,   478,   491,   479,   718,   276,   594,
     322,   487,   858,   804,   805,   806,   807,   859,   809,   623,
     323,   621,   853,   852,   852,   852,   852,   596,   606,   300,
     782,   590,   327,   909,   852,   852,   852,   400,   401,   256,
     855,   304,   920,   852,   306,   921,   262,   263,   359,   842,
     403,   404,   302,   695,   264,   556,   239,   696,   530,   363,
     571,   848,   697,   391,   556,   439,   319,   393,   320,   321,
     395,   408,   409,   258,   459,   461,   322,   568,   678,   262,
     263,   532,   949,   621,   621,   621,   621,   264,   621,   308,
     675,   309,   308,   423,   309,   669,   425,   853,   855,   467,
     663,   938,   673,   855,   665,   452,   958,   453,   -30,   668,
     682,   663,   684,   663,   686,   154,   666,   330,   637,   848,
     699,   270,   330,   126,   848,   272,   330,   156,   262,   263,
     287,   707,   158,   127,   289,   277,   264,   160,   162,   260,
     128,   862,   896,   863,   267,   855,   855,   855,   855,   279,
     281,   269,   129,   854,   291,   853,   855,   855,   855,   366,
     853,   164,   221,   589,   818,   855,   848,   848,   848,   848,
     283,   663,   663,   819,   707,   621,   842,   848,   848,   848,
     330,   262,   263,   814,   919,   130,   848,   777,   860,   264,
     285,   295,   696,   530,   297,   334,   336,   697,   621,   223,
     885,   893,   853,   853,   853,   853,   338,   346,   348,   886,
     894,   789,   241,   853,   853,   853,   532,   707,   131,   707,
     368,   350,   853,   370,   352,   354,   356,   360,   854,   364,
     372,   374,   661,   376,   672,   378,   132,   380,   676,   382,
     384,   386,   388,   661,   914,   661,   397,   915,   405,   247,
     744,   745,   698,   791,   155,   133,   916,   410,   663,   663,
     412,   414,   416,   418,   822,   911,   157,   744,   745,   775,
     732,   159,   420,   832,   426,   428,   161,   163,   912,   430,
     134,   955,   777,   838,   898,   935,   854,   856,   432,   434,
     726,   854,   436,   271,   262,   263,   699,   273,   262,   263,
     165,   222,   264,   661,   661,   866,   264,   278,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   707,   262,   263,
     135,   280,   282,   262,   263,   441,   264,   443,   445,   447,
     449,   264,   462,   854,   854,   854,   854,   464,   224,   917,
     922,   469,   284,   788,   854,   854,   854,   245,   918,   923,
     732,   136,   939,   854,   514,   515,   516,   517,   518,   519,
     520,   137,   286,   296,   243,   249,   298,   335,   337,   844,
     251,   522,  -456,  -456,   845,   523,   524,   138,   339,   347,
     349,   525,   526,   139,   262,   263,   140,   262,   263,   141,
     661,   661,   264,   351,   142,   264,   353,   355,   357,   361,
     253,   365,   373,   375,   830,   377,   143,   379,   929,   381,
     144,   383,   385,   387,   389,   837,   663,   145,   398,   939,
     406,   514,   515,   516,   517,   518,   519,   520,   698,   411,
     146,   835,   413,   415,   417,   419,   844,   865,   522,  -454,
    -454,   845,   523,   524,   421,   147,   427,   429,   525,   526,
     939,   431,   514,   515,   516,   517,   518,   519,   520,   828,
     433,   435,   744,   745,   437,   831,   530,   844,   647,   522,
     148,   293,   845,   523,   524,   149,   320,   321,   648,   525,
     526,   649,   150,   650,   322,   746,   527,   528,   939,   532,
     514,   515,   516,   517,   518,   519,   520,   442,   294,   444,
     446,   448,   450,   151,   463,   844,   152,   522,   153,   465,
     845,   523,   524,   470,   262,   263,   309,   525,   526,   320,
     321,   648,   264,   262,   263,   725,   529,   322,   530,   166,
     167,   264,   168,   846,   778,   530,  -456,   731,   775,   169,
     928,   588,   340,   779,   933,   170,   946,   959,   661,   926,
     171,   532,   172,   527,   528,   947,   960,   619,   532,   514,
     515,   516,   517,   518,   519,   520,   173,   262,   263,   320,
     321,   648,   174,   967,   521,   264,   522,   322,   836,   530,
     523,   524,   968,   175,   527,   528,   525,   526,   262,   263,
     262,   263,   -70,   529,   176,   530,   264,   177,   264,   932,
     846,   178,   532,  -454,   647,   179,  -365,  -365,   320,   321,
     648,   180,   320,   321,   648,   316,   322,   649,   532,   181,
     322,   341,   527,   528,   529,   182,   530,   577,   183,   184,
    -365,   846,   578,   579,   940,   185,   619,   186,   514,   515,
     516,   517,   518,   519,   520,   187,   262,   263,   542,   532,
     543,   544,   188,   521,   264,   522,   189,   787,   530,   523,
     524,   -68,   529,   192,   530,   525,   526,   195,   396,   846,
     196,   619,  -458,   514,   515,   516,   517,   518,   519,   520,
     197,   532,   963,   964,   965,   262,   263,   532,   521,   198,
     522,   527,   528,   264,   523,   524,   927,   530,   199,   200,
     525,   526,   201,   202,   203,   619,   204,   514,   515,   516,
     517,   518,   519,   520,   205,   206,   -70,   -70,   -70,   207,
     532,   208,   521,   209,   522,   -70,   -70,   -70,   523,   524,
     210,   529,   557,   530,   525,   526,   211,   494,   531,   212,
     213,   620,   214,   619,   215,   514,   515,   516,   517,   518,
     519,   520,   216,   262,   263,   906,   532,   743,   217,   218,
     521,   264,   522,   219,   864,   530,   523,   524,   220,   225,
     527,   528,   525,   526,   619,   495,   514,   515,   516,   517,
     518,   519,   520,   226,   227,   -68,   -68,   -68,   532,   228,
     229,   521,   230,   522,   -68,   -68,   -68,   523,   524,   231,
     792,   232,   793,   525,   526,   527,   528,   233,   456,   342,
     529,   343,   530,   941,   344,   345,   498,   531,   454,   619,
     626,   514,   515,   516,   517,   518,   519,   520,   308,   455,
     318,   319,   -35,   320,   321,   532,   521,   457,   522,   527,
     528,   322,   523,   524,   471,   529,   492,   530,   525,   526,
     493,   323,   531,   320,   512,   629,   558,   559,   560,   570,
     906,   906,   906,   507,   500,   561,   562,   563,   506,   504,
     532,   941,   941,   941,   508,   513,   573,   527,   528,   529,
     574,   530,   575,   576,   582,   583,   531,   634,   584,   630,
     585,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   586,   587,   555,   532,   597,   598,   599,   527,   528,
     439,   319,   600,   320,   321,   601,   602,   529,   624,   530,
     603,   322,   604,   618,   531,   625,   632,   631,   636,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   627,
     439,   319,   532,   320,   321,   628,   633,   639,   529,   635,
     530,   322,   640,   527,   528,   531,   824,   619,   823,   514,
     515,   516,   517,   518,   519,   520,   568,   320,   321,   648,
     643,   655,   729,   532,   521,   322,   522,   644,   656,   670,
     523,   524,   701,   702,   687,   689,   525,   526,   799,   800,
     801,   802,   803,   529,   691,   530,   711,   712,   713,   714,
     531,   715,   619,   878,   514,   515,   516,   517,   518,   519,
     520,   716,   722,   738,   760,   761,   762,   763,   532,   521,
     764,   522,   765,   767,   771,   523,   524,   766,   773,   783,
     786,   525,   526,   619,   808,   514,   515,   516,   517,   518,
     519,   520,   747,   748,   749,   750,   751,   752,   753,   754,
     521,   813,   522,   817,   821,   843,   523,   524,   827,   833,
     834,   882,   525,   526,   619,   857,   514,   515,   516,   517,
     518,   519,   520,   884,   889,   890,   891,   892,   897,   898,
     902,   521,   903,   522,   907,   910,   913,   523,   524,   924,
     948,   527,   528,   525,   526,   619,   925,   514,   515,   516,
     517,   518,   519,   520,   934,   943,   944,   952,   956,   957,
     953,   954,   521,   961,   522,   962,   969,   970,   523,   524,
     972,   973,   971,   974,   525,   526,   987,   975,   976,   978,
     980,   529,   979,   530,   981,   982,   527,   528,   531,   983,
     619,   879,   514,   515,   516,   517,   518,   519,   520,   984,
     985,   986,   988,   989,   236,   315,   532,   521,   505,   522,
     815,   642,   728,   523,   524,   820,   646,   527,   528,   525,
     526,   499,   931,   693,     0,   861,   529,     0,   530,   607,
     936,     0,     0,   531,     0,     0,   880,     0,   608,   609,
     610,   611,   612,   613,   614,   615,   616,     0,   527,   528,
       0,   532,     0,     0,     0,     0,     0,   529,     0,   530,
       0,     0,     0,     0,   531,     0,     0,   881,     0,   514,
     515,   516,   517,   518,   519,   520,     0,     0,     0,   527,
     528,     0,   532,     0,   521,     0,     0,     0,   529,     0,
     530,     0,     0,     0,     0,   531,   525,   526,   883,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,     0,
       0,   867,     0,   532,     0,     0,     0,     0,     0,   529,
       0,   530,     0,     0,   527,   528,   531,     0,     0,   930,
     514,   515,   516,   517,   518,   519,   520,     0,     0,     0,
       0,     0,     0,     0,   532,   844,     0,   522,     0,     0,
     845,   523,   524,     0,     0,     0,     0,   525,   526,     0,
       0,     0,     0,     0,   529,     0,   530,     0,     0,     0,
       0,   531,     0,     0,   945,     0,     0,     0,     0,     0,
       0,   514,   515,   516,   517,   518,   519,   520,     0,   532,
     514,   515,   516,   517,   518,   519,   520,     0,     0,     0,
       0,   527,   528,     0,     0,   844,     0,   522,   525,   526,
     845,   523,   524,     0,     0,     0,     0,   525,   526,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,     0,
       0,   262,   263,     0,     0,     0,   657,     0,     0,   264,
       0,   529,     0,   530,     0,     0,     0,     0,     0,   658,
     659,     0,   660,   514,   515,   516,   517,   518,   519,   520,
       0,     0,   527,   528,     0,     0,   532,     0,   521,     0,
     522,     0,     0,     0,   523,   524,     0,     0,     0,     0,
     525,   526,   607,   747,   748,   749,   750,   751,   752,   753,
     754,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,     0,   529,     0,   530,     0,     0,     0,     0,   846,
       0,   847,     0,   527,   528,     0,     0,     0,     0,     0,
       0,     0,   527,   528,     0,     0,     0,   532,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   262,   263,     0,     0,     0,     0,   703,
       0,   264,     0,   529,   704,   530,     0,     0,     0,     0,
       0,   705,   529,     0,   530,     0,     0,     0,     0,   846,
       0,     0,   904,     0,     0,     0,     0,     0,   532,     0,
       0,     0,     0,     0,     0,   527,   528,   532,   514,   515,
     516,   517,   518,   519,   520,     0,   514,   515,   516,   517,
     518,   519,   520,   521,     0,   522,     0,     0,     0,   523,
     524,   521,     0,   522,     0,   525,   526,   523,   524,     0,
       0,     0,     0,   525,   526,   529,     0,   530,     0,     0,
       0,     0,   531,     0,     0,   741,     0,     0,     0,   514,
     515,   516,   517,   518,   519,   520,     0,     0,     0,     0,
     532,     0,     0,     0,   844,     0,   522,     0,     0,   845,
     523,   524,     0,     0,     0,     0,   525,   526,   514,   515,
     516,   517,   518,   519,   520,     0,     0,     0,     0,     0,
       0,     0,     0,   521,     0,   522,     0,     0,     0,   523,
     524,     0,     0,     0,     0,   525,   526,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     527,   528,     0,     0,     0,     0,     0,     0,   527,   528,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     529,     0,   530,     0,     0,     0,     0,   531,   529,   840,
     530,   527,   528,     0,     0,   531,     0,     0,   895,     0,
       0,     0,     0,     0,     0,   532,     0,     0,     0,     0,
       0,     0,     0,   532,     0,     0,     0,     0,     0,     0,
     527,   528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   529,     0,   530,     0,     0,     0,     0,   846,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   532,     0,     0,     0,
     529,     0,   530,    -2,   235,     0,     0,   531,     0,     0,
       0,     0,    -8,   -10,   -12,   -14,   -16,   -18,   -20,   -22,
     -24,     0,     0,     0,     0,   532,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,    28,    29,    30,    31,    32,     0,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,     0,     0,     0,
     102,   103,   104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,    -8,   -10,   -12,   -14,   -16,
     -18,   -20,   -22,   -24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   105,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     0,    28,    29,    30,    31,    32,
       0,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
       0,     0,     0,   102,   103,   104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     105
};

static const yytype_int16 yycheck[] =
{
     124,   150,   150,     1,   214,   129,     1,     1,     1,   586,
     478,     1,   136,   137,   138,   483,     1,   485,   586,   487,
     597,     1,   599,   586,   635,     1,   597,     1,   599,   597,
     586,   599,   643,     1,   597,   647,   599,   649,     1,   177,
     617,   597,     1,   599,   535,     1,     1,   910,   497,   140,
       1,     1,   176,   177,   178,     1,   547,     1,     1,   550,
     551,   552,   200,     1,   476,   602,   214,   479,     1,   481,
     167,   204,   205,   772,   181,     1,     1,   489,     1,   491,
     657,   658,     1,   660,   150,     1,   657,   658,   195,   657,
     658,   140,   955,     1,   657,   658,     1,     1,   195,     1,
     173,   657,   658,     1,   172,   140,     1,   644,     1,   972,
     166,   722,     1,   181,     1,   564,   140,   729,     1,     0,
     172,     1,     1,   196,   176,     1,   703,     1,   705,     1,
       1,     1,     1,     1,   165,   166,   172,   193,   176,   177,
     176,   172,   173,   755,   172,     1,   177,     1,   847,     1,
       1,   172,     1,   181,   140,     1,   158,   159,   158,   159,
     181,   172,   200,     1,     1,   176,     9,   744,   745,   200,
     172,   140,   172,   744,   745,   173,   744,   745,   173,   328,
     328,   744,   745,   173,   596,   175,   176,   177,   744,   745,
     184,   659,   186,   186,     1,   772,   181,     1,   196,   172,
     185,   196,     1,   176,   184,   817,   905,   183,   819,     1,
     200,   910,   186,   176,   173,   183,   772,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   173,   184,   175,
     176,   186,   178,   179,   184,   186,   186,   196,   176,   183,
     186,   184,   779,   711,   712,   713,   714,     1,   716,   182,
     196,   742,   772,   952,   953,   954,   955,   183,   183,   175,
     183,   517,   328,   182,   963,   964,   965,   175,   176,   173,
     847,   176,   884,   972,   176,   886,   165,   166,   176,   770,
     175,   176,   175,   172,   173,   495,    10,   176,   177,   176,
     500,   847,   181,   176,   504,   175,   176,   176,   178,   179,
     176,   175,   176,   173,   176,   176,   186,   176,   176,   165,
     166,   200,   923,   804,   805,   806,   807,   173,   809,   173,
     176,   175,   173,   175,   175,   902,   175,   847,   905,   175,
     586,   902,   588,   910,   902,   173,   947,   175,   175,   902,
     596,   597,   598,   599,   600,     1,   902,   495,   558,   905,
     606,     1,   500,   140,   910,     1,   504,     1,   165,   166,
       1,   617,     1,   140,     1,     1,   173,     1,     1,   173,
     140,   783,   840,   785,   173,   952,   953,   954,   955,     1,
       1,   173,   140,   772,     1,   905,   963,   964,   965,     1,
     910,     1,     1,   517,   172,   972,   952,   953,   954,   955,
       1,   657,   658,   181,   660,   896,   897,   963,   964,   965,
     558,   165,   166,   172,   882,   140,   972,   176,   172,   173,
       1,     1,   176,   177,     1,     1,     1,   181,   919,     1,
     172,   172,   952,   953,   954,   955,     1,     1,     1,   181,
     181,   697,    11,   963,   964,   965,   200,   703,   140,   705,
       1,     1,   972,     1,     1,     1,     1,     1,   847,     1,
       1,     1,   586,     1,   588,     1,   140,     1,   592,     1,
       1,     1,     1,   597,   172,   599,     1,   172,     1,    14,
     158,   159,   606,   181,   140,   140,   181,     1,   744,   745,
       1,     1,     1,     1,   172,   172,   140,   158,   159,   176,
     649,   140,     1,   759,     1,     1,   140,   140,   172,     1,
     140,   172,   176,   769,    21,    22,   905,   773,     1,     1,
     644,   910,     1,   173,   165,   166,   782,   173,   165,   166,
     140,   140,   173,   657,   658,   791,   173,   173,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   803,   165,   166,
     140,   173,   173,   165,   166,     1,   173,     1,     1,     1,
       1,   173,     1,   952,   953,   954,   955,     1,   140,   172,
     172,     1,   173,   697,   963,   964,   965,    13,   181,   181,
     729,   140,     1,   972,     3,     4,     5,     6,     7,     8,
       9,   140,   173,   173,    12,    15,   173,   173,   173,    18,
      16,    20,    21,    22,    23,    24,    25,   140,   173,   173,
     173,    30,    31,   140,   165,   166,   140,   165,   166,   140,
     744,   745,   173,   173,   140,   173,   173,   173,   173,   173,
      17,   173,   173,   173,   758,   173,   140,   173,   894,   173,
     140,   173,   173,   173,   173,   769,   902,   140,   173,     1,
     173,     3,     4,     5,     6,     7,     8,     9,   782,   173,
     140,    29,   173,   173,   173,   173,    18,   791,    20,    21,
      22,    23,    24,    25,   173,   140,   173,   173,    30,    31,
       1,   173,     3,     4,     5,     6,     7,     8,     9,    29,
     173,   173,   158,   159,   173,   176,   177,    18,   170,    20,
     140,   176,    23,    24,    25,   140,   178,   179,   180,    30,
      31,   183,   140,   185,   186,   181,   135,   136,     1,   200,
       3,     4,     5,     6,     7,     8,     9,   173,   176,   173,
     173,   173,   173,   140,   173,    18,   140,    20,   140,   173,
      23,    24,    25,   173,   165,   166,   175,    30,    31,   178,
     179,   180,   173,   165,   166,   176,   175,   186,   177,   140,
     140,   173,   140,   182,   172,   177,   185,   196,   176,   140,
     894,   183,   173,   181,   898,   140,   172,   172,   902,    29,
     140,   200,   140,   135,   136,   181,   181,     1,   200,     3,
       4,     5,     6,     7,     8,     9,   140,   165,   166,   178,
     179,   180,   140,   172,    18,   173,    20,   186,   176,   177,
      24,    25,   181,   140,   135,   136,    30,    31,   165,   166,
     165,   166,    64,   175,   140,   177,   173,   140,   173,   176,
     182,   140,   200,   185,   170,   140,   176,   177,   178,   179,
     180,   140,   178,   179,   180,   176,   186,   183,   200,   140,
     186,   173,   135,   136,   175,   140,   177,    22,   140,   140,
     200,   182,    27,    28,   185,   140,     1,   140,     3,     4,
       5,     6,     7,     8,     9,   140,   165,   166,   173,   200,
     175,   176,   140,    18,   173,    20,   140,   176,   177,    24,
      25,    64,   175,   140,   177,    30,    31,   140,   176,   182,
     140,     1,   185,     3,     4,     5,     6,     7,     8,     9,
     140,   200,   952,   953,   954,   165,   166,   200,    18,   140,
      20,   135,   136,   173,    24,    25,   176,   177,   140,   140,
      30,    31,   140,   140,   140,     1,   140,     3,     4,     5,
       6,     7,     8,     9,   140,   140,   188,   189,   190,   140,
     200,   140,    18,   140,    20,   197,   198,   199,    24,    25,
     140,   175,    64,   177,    30,    31,   140,     1,   182,   140,
     140,   185,   140,     1,   140,     3,     4,     5,     6,     7,
       8,     9,   140,   165,   166,   847,   200,   660,   140,   140,
      18,   173,    20,   140,   176,   177,    24,    25,   140,   140,
     135,   136,    30,    31,     1,   195,     3,     4,     5,     6,
       7,     8,     9,   140,   140,   188,   189,   190,   200,   140,
     140,    18,   140,    20,   197,   198,   199,    24,    25,   140,
     703,   140,   705,    30,    31,   135,   136,   140,   175,   173,
     175,   173,   177,   905,   173,   173,   195,   182,   173,     1,
     185,     3,     4,     5,     6,     7,     8,     9,   173,   173,
     175,   176,   195,   178,   179,   200,    18,   173,    20,   135,
     136,   186,    24,    25,   173,   175,   173,   177,    30,    31,
     173,   196,   182,   178,   201,   185,   188,   189,   190,   187,
     952,   953,   954,   181,   195,   197,   198,   199,   190,   195,
     200,   963,   964,   965,   190,   190,   175,   135,   136,   175,
     175,   177,   176,   175,   184,   173,   182,   195,   175,   185,
     183,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   183,   183,   168,   200,   183,   183,   183,   135,   136,
     175,   176,   183,   178,   179,   183,   183,   175,   187,   177,
     183,   186,   183,   182,   182,   187,   181,   185,   175,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   187,
     175,   176,   200,   178,   179,   187,   187,   173,   175,   195,
     177,   186,   175,   135,   136,   182,   187,     1,   185,     3,
       4,     5,     6,     7,     8,     9,   176,   178,   179,   180,
     195,   203,   183,   200,    18,   186,    20,   181,   172,   172,
      24,    25,    29,    29,   176,   176,    30,    31,   165,   166,
     167,   168,   169,   175,   175,   177,   184,   184,   184,   184,
     182,   173,     1,   185,     3,     4,     5,     6,     7,     8,
       9,   184,   195,   173,   172,   172,   172,   172,   200,    18,
     181,    20,   172,   172,   172,    24,    25,   181,    26,   181,
     172,    30,    31,     1,   187,     3,     4,     5,     6,     7,
       8,     9,   141,   142,   143,   144,   145,   146,   147,   148,
      18,   172,    20,   181,   169,   184,    24,    25,   176,   176,
     176,   184,    30,    31,     1,   176,     3,     4,     5,     6,
       7,     8,     9,   181,    25,   172,   172,   172,    19,    21,
     183,    18,   182,    20,   182,   172,   172,    24,    25,   172,
     172,   135,   136,    30,    31,     1,   173,     3,     4,     5,
       6,     7,     8,     9,   185,   173,   176,   195,   172,   172,
     195,   195,    18,   202,    20,   173,   176,   173,    24,    25,
      19,   176,   202,   172,    30,    31,   204,   203,   173,   172,
     203,   175,   173,   177,   169,   173,   135,   136,   182,    25,
       1,   185,     3,     4,     5,     6,     7,     8,     9,   169,
     173,    25,   173,   204,   107,   148,   200,    18,   328,    20,
     729,   568,   645,    24,    25,   736,   581,   135,   136,    30,
      31,   322,   897,   604,    -1,   782,   175,    -1,   177,   140,
     900,    -1,    -1,   182,    -1,    -1,   185,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,    -1,   135,   136,
      -1,   200,    -1,    -1,    -1,    -1,    -1,   175,    -1,   177,
      -1,    -1,    -1,    -1,   182,    -1,    -1,   185,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,   135,
     136,    -1,   200,    -1,    18,    -1,    -1,    -1,   175,    -1,
     177,    -1,    -1,    -1,    -1,   182,    30,    31,   185,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
      -1,   172,    -1,   200,    -1,    -1,    -1,    -1,    -1,   175,
      -1,   177,    -1,    -1,   135,   136,   182,    -1,    -1,   185,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,    18,    -1,    20,    -1,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    -1,    -1,    -1,   175,    -1,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,   185,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    -1,   200,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,   135,   136,    -1,    -1,    18,    -1,    20,    30,    31,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
      -1,   165,   166,    -1,    -1,    -1,   170,    -1,    -1,   173,
      -1,   175,    -1,   177,    -1,    -1,    -1,    -1,    -1,   183,
     184,    -1,   186,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,   135,   136,    -1,    -1,   200,    -1,    18,    -1,
      20,    -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
      -1,    -1,   175,    -1,   177,    -1,    -1,    -1,    -1,   182,
      -1,   184,    -1,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,   136,    -1,    -1,    -1,   200,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   165,   166,    -1,    -1,    -1,    -1,   171,
      -1,   173,    -1,   175,   176,   177,    -1,    -1,    -1,    -1,
      -1,   183,   175,    -1,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,   185,    -1,    -1,    -1,    -1,    -1,   200,    -1,
      -1,    -1,    -1,    -1,    -1,   135,   136,   200,     3,     4,
       5,     6,     7,     8,     9,    -1,     3,     4,     5,     6,
       7,     8,     9,    18,    -1,    20,    -1,    -1,    -1,    24,
      25,    18,    -1,    20,    -1,    30,    31,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,   175,    -1,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,   185,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
     200,    -1,    -1,    -1,    18,    -1,    20,    -1,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    31,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    -1,    20,    -1,    -1,    -1,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,   135,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     175,    -1,   177,    -1,    -1,    -1,    -1,   182,   175,   184,
     177,   135,   136,    -1,    -1,   182,    -1,    -1,   185,    -1,
      -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,    -1,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   175,    -1,   177,    -1,    -1,    -1,    -1,   182,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,
     175,    -1,   177,     0,     1,    -1,    -1,   182,    -1,    -1,
      -1,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,    -1,    -1,    -1,
     137,   138,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
      -1,    -1,    -1,   137,   138,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    59,    60,
      61,    62,    63,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   137,   138,   139,   194,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   244,   245,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,     1,   140,     1,   140,     1,   140,
       1,   140,     1,   140,     1,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
       1,   176,   140,     1,   183,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,     1,   140,     1,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,     0,     1,   210,     9,   254,    10,
     255,    11,   256,    12,   257,    13,   258,    14,   259,    15,
     260,    16,   261,    17,   262,     1,   173,     1,   173,     1,
     173,     1,   165,   166,   173,   225,     1,   173,     1,   173,
       1,   173,     1,   173,   225,     1,   176,     1,   173,     1,
     173,     1,   173,     1,   173,     1,   173,     1,   225,     1,
     225,     1,   225,   176,   176,     1,   173,     1,   173,     1,
     175,     1,   175,     1,   176,     1,   176,     1,   173,   175,
     223,   226,   227,   233,     1,   233,   176,     1,   175,   176,
     178,   179,   186,   196,   220,   222,   223,   226,   228,   229,
     246,   247,   248,   249,     1,   173,     1,   173,     1,   173,
     173,   173,   173,   173,   173,   173,     1,   173,     1,   173,
       1,   173,     1,   173,     1,   173,     1,   173,     1,   176,
       1,   173,     1,   176,     1,   173,     1,   225,     1,   225,
       1,   225,     1,   173,     1,   173,     1,   173,     1,   173,
       1,   173,     1,   173,     1,   173,     1,   173,     1,   173,
       1,   176,     1,   176,     1,   176,   176,     1,   173,     1,
     175,   176,     1,   175,   176,     1,   173,     1,   175,   176,
       1,   173,     1,   173,     1,   173,     1,   173,     1,   173,
       1,   173,     1,   175,     1,   175,     1,   173,     1,   173,
       1,   173,     1,   173,     1,   173,     1,   173,     1,   175,
     220,     1,   173,     1,   173,     1,   173,     1,   173,     1,
     173,     1,   173,   175,   173,   173,   175,   173,     1,   176,
       1,   176,     1,   173,     1,   173,     1,   175,   243,     1,
     173,   173,     1,   184,   186,     1,   186,     1,   184,   186,
       1,   186,     1,   184,     1,   184,     1,   184,     1,   186,
       1,   186,   173,   173,     1,   195,   235,   234,   195,   248,
     195,   166,   193,   221,   195,   229,   190,   181,   190,   167,
     195,   239,   201,   190,     3,     4,     5,     6,     7,     8,
       9,    18,    20,    24,    25,    30,    31,   135,   136,   175,
     177,   182,   200,   269,   274,   278,   280,   283,   284,   285,
     286,   294,   173,   175,   176,   252,   252,   278,   252,   252,
     278,   278,   278,   252,   252,   168,   220,    64,   188,   189,
     190,   197,   198,   199,   231,   232,   232,     1,   176,   237,
     187,   220,     1,   175,   175,   176,   175,    22,    27,    28,
     240,   241,   184,   173,   175,   183,   183,   183,   183,   225,
     269,     1,   183,     1,   183,     1,   183,   183,   183,   183,
     183,   183,   183,   183,   183,     1,   183,   140,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   272,   182,     1,
     185,   280,     1,   182,   187,   187,   185,   187,   187,   185,
     185,   185,   181,   187,   195,   195,   175,   220,   230,   173,
     175,   232,   237,   195,   181,   181,   239,   170,   180,   183,
     185,   238,   242,   246,   250,   203,   172,   170,   183,   184,
     186,   225,   263,   269,   270,   271,   274,   275,   283,   294,
     172,   172,   225,   269,     1,   176,   225,     1,   176,     1,
     252,   253,   269,   263,   269,   263,   269,   176,   251,   176,
     251,   175,   293,   293,     1,   172,   176,   181,   225,   269,
     291,    29,    29,   171,   176,   183,   225,   269,   271,   273,
     294,   184,   184,   184,   184,   173,   184,   173,   196,   224,
       1,   224,   195,     1,   224,   176,   225,   251,   240,   183,
     250,   196,   223,   236,   250,     1,   181,   185,   173,   263,
     263,   185,   278,   273,   158,   159,   181,   141,   142,   143,
     144,   145,   146,   147,   148,   264,   265,   266,   267,   268,
     172,   172,   172,   172,   181,   172,   181,   172,   172,   181,
     172,   172,   172,    26,   172,   176,   172,   176,   172,   181,
     172,     1,   183,   181,   172,   181,   172,   176,   225,   269,
     172,   181,   273,   273,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   278,   278,   278,   278,   187,   278,
       1,   224,   172,   172,   172,   236,   250,   181,   172,   181,
     238,   169,   172,   185,   187,   263,   263,   176,    29,   250,
     225,   176,   269,   176,   176,    29,   176,   225,   269,   292,
     184,   277,   280,   184,    18,    23,   182,   184,   274,   276,
     281,   282,   284,   285,   286,   294,   269,   176,   251,     1,
     172,   291,   252,   252,   176,   225,   269,   172,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   185,   185,
     185,   185,   184,   185,   181,   172,   181,   250,   224,    25,
     172,   172,   172,   172,   181,   185,   278,    19,    21,   287,
     288,   289,   183,   182,   185,   279,   281,   182,     1,   182,
     172,   172,   172,   172,   172,   172,   181,   172,   181,   278,
     250,   224,   172,   181,   172,   173,    29,   176,   225,   269,
     185,   277,   176,   225,   185,    22,   289,   290,   263,     1,
     185,   281,   276,   173,   176,   185,   172,   181,   172,   224,
     204,   205,   195,   195,   195,   172,   172,   172,   224,   172,
     181,   202,   173,   279,   279,   279,   276,   172,   181,   176,
     173,   202,    19,   176,   172,   203,   173,   276,   172,   173,
     203,   169,   173,    25,   169,   173,    25,   204,   173,   204
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   207,   208,   209,   209,   209,   210,   210,   211,   210,
     212,   210,   213,   210,   214,   210,   215,   210,   216,   210,
     217,   210,   218,   210,   219,   210,   210,   220,   220,   220,
     221,   221,   222,   222,   222,   223,   224,   224,   225,   225,
     225,   226,   226,   226,   226,   227,   227,   228,   228,   228,
     228,   228,   229,   229,   230,   230,   230,   231,   231,   231,
     231,   231,   231,   231,   232,   232,   233,   233,   234,   233,
     235,   233,   236,   236,   237,   237,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   239,   239,
     239,   240,   240,   240,   241,   241,   242,   242,   242,   243,
     243,   243,   243,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   245,   245,
     245,   245,   245,   245,   246,   246,   247,   248,   249,   249,
     250,   250,   251,   251,   252,   252,   252,   253,   253,   254,
     254,   254,   255,   255,   256,   256,   256,   257,   257,   258,
     258,   259,   259,   260,   260,   261,   261,   262,   262,   263,
     263,   263,   263,   263,   263,   264,   264,   265,   265,   265,
     265,   266,   266,   267,   267,   268,   268,   268,   269,   269,
     270,   270,   270,   270,   271,   271,   271,   271,   271,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   274,   274,   274,   275,
     275,   275,   275,   275,   276,   276,   276,   277,   277,   277,
     278,   278,   278,   279,   279,   279,   280,   280,   280,   280,
     280,   280,   280,   280,   281,   281,   281,   281,   281,   281,
     281,   281,   281,   282,   282,   283,   283,   284,   285,   286,
     287,   287,   288,   288,   289,   289,   289,   289,   290,   290,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,   292,   292,   292,   292,   292,   292,   292,   292,   293,
     293,   293,   293,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     1,     1,
       2,     2,     2,     2,     1,     2,     1,     1,     0,     3,
       0,     3,     1,     1,     1,     2,     9,    10,     7,     8,
       5,     6,     5,     6,     3,     4,     1,     2,     4,     3,
       0,     1,     1,     1,     3,     1,     3,     1,     2,    18,
      17,    10,     9,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     3,
       3,     3,     3,     5,     3,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     5,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     6,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
       8,     8,     8,     2,     1,     1,     1,     1,     1,     3,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     4,
       7,     2,     7,     2,     4,     7,     2,     7,     2,     4,
       2,     4,     2,     4,     2,     9,     2,     7,     2,     3,
       3,     2,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     1,
       1,     1,     3,     2,     1,     3,     2,     1,     3,     2,
       2,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     2,     1,     2,     2,     2,     1,     1,     1,     1,
       2,     1,     2,     5,     7,     5,     7,     5,     7,     7,
       2,     1,     2,     1,     4,     3,     4,     3,     3,     2,
       1,     3,     1,     2,     2,     1,     2,     3,     1,     2,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       4,     4,     2,     6,     1,     3,     1,     3,     2,     4,
       2,     4,     3,     1,     4,     6,     2,     4,     6,     2,
       4,     4,     6,     2,     4,     3,     4,     4,     2,     4,
       4,     4,     4,     6,     6,     6,     8,     8,     6,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 503 "cfg.y" /* yacc.c:1646  */
    {}
#line 2599 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 504 "cfg.y" /* yacc.c:1646  */
    {}
#line 2605 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 505 "cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 2611 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 510 "cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 2617 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 511 "cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 2623 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 512 "cfg.y" /* yacc.c:1646  */
    {rt=ONREPLY_ROUTE;}
#line 2629 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 513 "cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 2635 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 514 "cfg.y" /* yacc.c:1646  */
    {rt=ERROR_ROUTE;}
#line 2641 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 515 "cfg.y" /* yacc.c:1646  */
    {rt=LOCAL_ROUTE;}
#line 2647 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 516 "cfg.y" /* yacc.c:1646  */
    {rt=STARTUP_ROUTE;}
#line 2653 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 517 "cfg.y" /* yacc.c:1646  */
    {rt=TIMER_ROUTE;}
#line 2659 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 518 "cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 2665 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 523 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2685 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 538 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2699 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 547 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2717 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 562 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)=".";}
#line 2723 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 563 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)="-"; }
#line 2729 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 566 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 2735 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 567 "cfg.y" /* yacc.c:1646  */
    { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2754 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 581 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2762 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 586 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2775 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 596 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2781 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 597 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 2787 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 600 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2793 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 601 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2799 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 602 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 2805 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 606 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2812 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 608 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2819 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 610 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2829 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 615 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2838 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 621 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2845 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 623 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2852 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 627 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2859 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 629 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2866 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 631 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2873 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 633 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 640 "cfg.y" /* yacc.c:1646  */
    { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2888 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 641 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2894 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 644 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2901 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 646 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2908 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 648 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2917 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 654 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2925 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 657 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_FRAG;
					}
#line 2933 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 660 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_REUSEPORT;
					}
#line 2941 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 663 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2949 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 666 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2957 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 669 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2965 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 672 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2973 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 681 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2979 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 682 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2985 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 683 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2993 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 685 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 3001 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 688 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 3009 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 690 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 3017 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 695 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_NONE; }
#line 3023 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 696 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 3029 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 698 "cfg.y" /* yacc.c:1646  */
    {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 3035 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 699 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 3041 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 702 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3054 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 710 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3068 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 719 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),(yyvsp[-5].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3079 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 725 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),(yyvsp[-5].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3091 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 732 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,(yyvsp[-3].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3102 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 738 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,(yyvsp[-3].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3114 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 745 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3125 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 751 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3137 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 758 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3148 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 764 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3160 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 771 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3171 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 777 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3183 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 791 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_READONLY_LIST; }
#line 3189 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 792 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_DO_EXPIRE; }
#line 3195 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 793 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_BY_DEFAULT; }
#line 3201 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 796 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval); }
#line 3207 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 797 "cfg.y" /* yacc.c:1646  */
    {}
#line 3213 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 800 "cfg.y" /* yacc.c:1646  */
    {}
#line 3219 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 801 "cfg.y" /* yacc.c:1646  */
    {}
#line 3225 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 802 "cfg.y" /* yacc.c:1646  */
    { yyerror("bad black list element");}
#line 3231 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 809 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3241 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 817 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3251 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 823 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3261 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 829 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3271 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 836 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3280 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 840 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (*(yyvsp[0].strval)) {
				int len = strlen((yyvsp[0].strval));
				char *buf = pkg_malloc(len + 2);
				if (!buf)
					yyerror("oom");
				sprintf(buf, "%s:", (yyvsp[0].strval));
				log_prefix = buf;
			} else {
				log_prefix = (yyvsp[0].strval);
			}
			}
#line 3297 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 852 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3303 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 853 "cfg.y" /* yacc.c:1646  */
    { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3309 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 854 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3315 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 855 "cfg.y" /* yacc.c:1646  */
    { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3321 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 856 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3327 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 857 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) {
				*log_level = L_DBG;
				stderr_enabled=1;
				syslog_enabled=0;

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 0);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 1);
			}
			}
#line 3347 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 873 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected for debug_mode"); }
#line 3353 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 876 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 3359 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 877 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3365 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 878 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			warn("'log_stderror' is deprecated, use 'stderror_enabled' and/or"
				"'syslog_enabled' instead");
			if (!config_check && !debug_mode) {
				if ((yyvsp[0].intval)) {
					stderr_enabled=1;
					syslog_enabled=0;
				} else {
					stderr_enabled=0;
					syslog_enabled=1;
				}

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, (yyvsp[0].intval));
			}
			}
#line 3391 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 899 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3397 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 900 "cfg.y" /* yacc.c:1646  */
    {
			/* in config-check or debug mode we force logging
			 * to standard error */
			IFOR();
			if (!config_check && !debug_mode) {
				stderr_enabled=(yyvsp[0].intval);
				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3413 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 911 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3419 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 912 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			/* in config-check or debug mode we force logging
			 * to standard error */
			if (!config_check && !debug_mode) {
				syslog_enabled=(yyvsp[0].intval);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3435 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 923 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3441 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 924 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			if ((yyvsp[0].intval)) {
				if (init_log_msg_buf(0) < 0) {
					yyerror("failed to allocate msg log buffer");
					YYABORT;
				}
			}
			log_event_enabled=(yyvsp[0].intval); }
#line 3455 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 933 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3461 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 934 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			s_tmp.s=STDERR_CONSUMER_NAME;
			s_tmp.len=strlen(STDERR_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3472 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 940 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3478 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 941 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			s_tmp.s=SYSLOG_CONSUMER_NAME;
			s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3489 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 947 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3495 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 948 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							log_event_level_filter = (yyvsp[0].intval); }
#line 3502 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 950 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3508 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 951 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}

					if (i_tmp == LOG_FORMAT_JSON_CEE && init_log_cee_hostname() < 0) {
						yyerror("failed to allocate hostname buffer");
						YYABORT;
					}
				}

				stderr_log_format = i_tmp;
			}
			}
#line 3538 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 976 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}

					if (i_tmp == LOG_FORMAT_JSON_CEE && init_log_cee_hostname() < 0) {
						yyerror("failed to allocate hostname buffer");
						YYABORT;
					}
				}

				syslog_log_format = i_tmp;
			}
			}
#line 3568 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1001 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			log_json_buf_size = (yyvsp[0].intval);
			if (init_log_json_buf(1) < 0) {
				yyerror("failed to realloc json log buffer");
				YYABORT;
			}
			}
#line 3581 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1009 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3587 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1010 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			log_msg_buf_size = (yyvsp[0].intval);
			if (init_log_msg_buf(1) < 0) {
				yyerror("failed to realloc msg log buffer");
				YYABORT;
			}
			}
#line 3600 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1018 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3606 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1019 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			warn("'log_facility' is deprecated, use 'syslog_facility' instead");
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3618 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1026 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3624 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1027 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3635 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1033 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3641 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1034 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			warn("'log_name' is deprecated, use 'syslog_name' instead");
			log_name=(yyvsp[0].strval); }
#line 3649 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1037 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3655 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1038 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_name=(yyvsp[0].strval); }
#line 3661 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1039 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3667 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1040 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3673 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1041 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3679 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1042 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3685 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1043 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3691 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1044 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3697 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1045 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3703 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1046 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3709 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1047 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3715 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1048 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3721 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1049 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3727 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1050 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3733 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1051 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3739 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1052 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3745 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1053 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3751 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1054 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3757 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1055 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3763 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1056 "cfg.y" /* yacc.c:1646  */
    { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3769 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1057 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3775 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1058 "cfg.y" /* yacc.c:1646  */
    { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3781 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1059 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3787 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1060 "cfg.y" /* yacc.c:1646  */
    { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3793 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1061 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3802 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1065 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3808 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1066 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3816 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1069 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3825 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1073 "cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 3831 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1074 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3837 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1075 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3850 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1083 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3863 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1091 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3876 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1099 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3889 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1107 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3902 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1115 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3915 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1123 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3928 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1131 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3941 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1139 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3954 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1147 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3967 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1155 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3975 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1158 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3981 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1159 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3989 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1162 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3995 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1163 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 4001 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1164 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4007 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1165 "cfg.y" /* yacc.c:1646  */
    { IFOR(); shm_memlog_size=(yyvsp[0].intval);}
#line 4013 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1166 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4019 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1167 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memdump=(yyvsp[0].intval); }
#line 4025 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1168 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4031 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1169 "cfg.y" /* yacc.c:1646  */
    {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 4037 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1170 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4043 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1171 "cfg.y" /* yacc.c:1646  */
    { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 4049 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1172 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4055 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1173 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 4061 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1174 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4067 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1175 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 4082 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1185 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4088 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1186 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 4107 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1200 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4113 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1201 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 4119 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1202 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4125 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1203 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 4131 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1204 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4137 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1205 "cfg.y" /* yacc.c:1646  */
    { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 4143 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1206 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4149 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1207 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4155 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1208 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4161 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1209 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4167 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1210 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4173 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1211 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4179 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1212 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4185 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1213 "cfg.y" /* yacc.c:1646  */
    { IFOR(); mhomed=(yyvsp[0].intval); }
#line 4191 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1214 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4197 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1215 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 4212 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1225 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 4227 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1235 "cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 4233 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1236 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) < TCP_ALIAS_NEVER || (yyvsp[0].intval) > TCP_ALIAS_ALWAYS)
					yyerror("invalid 'tcp_accept_aliases' value");
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 4243 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1241 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4249 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1242 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 4257 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1245 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4266 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1249 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4272 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1250 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) <= 0)
					yyerror("invalid 'tcp_connect_timeout' (value too low!)");
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 4282 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1255 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4288 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1256 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 4296 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1259 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4302 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1260 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 4310 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1263 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4316 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1264 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 4324 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1267 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4330 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1268 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4342 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1275 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 4348 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1276 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 4360 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1283 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 4366 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1285 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_keepalive=!!(yyvsp[0].intval);
		}
#line 4374 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1288 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4380 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1289 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 4388 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1292 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4394 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1293 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_parallel_read_on_workers=!!(yyvsp[0].intval);
		}
#line 4402 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1296 "cfg.y" /* yacc.c:1646  */
    {
			yyerror("boolean value expected");
		}
#line 4410 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1299 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 4422 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1306 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4428 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1307 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 4440 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1314 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4446 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1315 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 4458 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1322 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4464 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1323 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 4471 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1325 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4477 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1326 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 4486 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1330 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4492 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1331 "cfg.y" /* yacc.c:1646  */
    { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 4500 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1334 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4506 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1335 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 4513 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1337 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4519 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1338 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 4526 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1340 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 4533 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1342 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 4540 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1344 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4546 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1345 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4552 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1346 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4558 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1347 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4565 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1349 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4571 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1350 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 4583 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1357 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4591 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1360 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4604 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1368 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4612 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1371 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4661 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1415 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid or no module specified"); }
#line 4667 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1416 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4677 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1421 "cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4684 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1423 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4691 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1425 "cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 4697 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1426 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4708 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1432 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4715 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1434 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4734 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1448 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4741 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1450 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4749 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1453 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4755 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1454 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4763 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1457 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4769 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1458 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4781 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1465 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4787 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1466 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4799 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1473 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected as tos"); }
#line 4805 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1474 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4814 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1478 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4847 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1506 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4853 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1507 "cfg.y" /* yacc.c:1646  */
    {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4860 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1509 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4866 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1510 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4874 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1513 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4880 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1514 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4888 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1517 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4894 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1518 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-3].strval);
				s_tmp.len = strlen((yyvsp[-3].strval));
				if (create_bl_head(_str("script"), (yyvsp[-1].intval),
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4909 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1528 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-1].strval);
				s_tmp.len = strlen((yyvsp[-1].strval));
				if (create_bl_head(_str("script"), BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4924 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1538 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4931 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1540 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4938 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1542 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4944 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1543 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4951 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1545 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4957 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1546 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4964 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1548 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4972 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1551 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4979 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1553 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4987 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1556 "cfg.y" /* yacc.c:1646  */
    {}
#line 4993 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1557 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("bad auto-scaling profile definition");
				}
#line 5001 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1560 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 5008 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1562 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 5016 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1565 "cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 5022 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1568 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 5031 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1572 "cfg.y" /* yacc.c:1646  */
    { yyerror("string expected");  }
#line 5037 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1573 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5048 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1579 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5059 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1585 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5070 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1591 "cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 5076 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1595 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5082 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1596 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5088 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1599 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 5107 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1615 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 5126 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1631 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5132 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1632 "cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 5138 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1635 "cfg.y" /* yacc.c:1646  */
    {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 5149 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1641 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 5158 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1651 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5173 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1661 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5188 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1672 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 5196 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1675 "cfg.y" /* yacc.c:1646  */
    {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 5210 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1684 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 5218 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1689 "cfg.y" /* yacc.c:1646  */
    {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 5246 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1712 "cfg.y" /* yacc.c:1646  */
    {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 5255 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1717 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 5268 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1725 "cfg.y" /* yacc.c:1646  */
    {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 5289 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1741 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 5295 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1744 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 5306 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1750 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 5312 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1753 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 5325 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1761 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 5336 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1767 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 5342 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1770 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 5353 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1776 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 5359 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1779 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 5372 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1787 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid error_route statement"); }
#line 5378 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1790 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 5391 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1798 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid local_route statement"); }
#line 5397 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1801 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 5410 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1809 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid startup_route statement"); }
#line 5416 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1812 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 5434 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1825 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid timer_route statement"); }
#line 5440 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1828 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 5451 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1834 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 5457 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1839 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5463 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1840 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 5469 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1841 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 5475 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1842 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 5481 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1843 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[-1].expr); }
#line 5487 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1844 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[0].expr); }
#line 5493 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1847 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 5499 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1848 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 5505 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1851 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 5511 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1852 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 5517 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1853 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 5523 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1854 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 5529 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1856 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 5535 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1857 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=NOTMATCH_OP; }
#line 5541 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1860 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5547 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1861 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5553 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1864 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5559 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1865 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5565 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1866 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5571 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1869 "cfg.y" /* yacc.c:1646  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5592 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1885 "cfg.y" /* yacc.c:1646  */
    {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5600 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1890 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=(yyvsp[0].expr); }
#line 5606 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1891 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5612 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1892 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5619 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1894 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5627 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1899 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5635 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1902 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5643 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1905 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5651 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1908 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5659 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1911 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5667 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1917 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = EQ_T; }
#line 5673 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1918 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = COLONEQ_T; }
#line 5679 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1919 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = PLUSEQ_T; }
#line 5685 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1920 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MINUSEQ_T;}
#line 5691 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1921 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = DIVEQ_T; }
#line 5697 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1922 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MULTEQ_T; }
#line 5703 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1923 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MODULOEQ_T; }
#line 5709 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1924 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BANDEQ_T; }
#line 5715 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1925 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BOREQ_T; }
#line 5721 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1926 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BXOREQ_T; }
#line 5727 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1930 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5733 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1931 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5739 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1932 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5745 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1933 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)= (yyvsp[0].expr); }
#line 5751 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1934 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5757 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1935 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5765 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1938 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5773 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1941 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5781 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1944 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5789 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1947 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5797 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1950 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5805 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1953 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5813 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1956 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5821 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1959 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5829 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1962 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5837 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1965 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5845 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1968 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5851 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1971 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5869 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1984 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5887 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1997 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5905 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2012 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5911 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2013 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5917 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2014 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5923 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2015 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5929 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2016 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5935 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2019 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5941 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2020 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5947 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2021 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5953 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2024 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5959 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2025 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5965 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2026 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5971 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2029 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5977 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2030 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5983 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2031 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5989 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2035 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5995 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2036 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6001 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2037 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 6007 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2040 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6013 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2041 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6019 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2042 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6025 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2043 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6031 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2044 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6037 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2045 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6043 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2046 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 6049 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2047 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6055 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2050 "cfg.y" /* yacc.c:1646  */
    { mk_action0((yyval.action), BREAK_T);}
#line 6061 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2051 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6067 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2052 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6073 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2053 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6079 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2054 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6085 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2055 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6091 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2056 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6097 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2057 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 6103 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2058 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6109 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2061 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6122 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2069 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6135 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2079 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6148 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2087 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6161 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2097 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 6172 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2105 "cfg.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 6193 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2123 "cfg.y" /* yacc.c:1646  */
    {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 6205 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2132 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6211 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2133 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6217 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2135 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6223 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2136 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6229 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2139 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 6240 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2145 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 6251 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2151 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 6262 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2157 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 6273 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2165 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 6281 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2168 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 6287 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2171 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 6297 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2176 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6312 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2186 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 6324 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2193 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 6336 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2200 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 6351 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2210 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 6361 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2215 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 6373 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2222 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6388 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2232 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 6398 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2237 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 6410 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2244 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6425 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2256 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 6435 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2261 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 6445 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2266 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 6455 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2271 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 6465 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2276 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6480 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2286 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6495 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2296 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6510 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2306 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6525 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2318 "cfg.y" /* yacc.c:1646  */
    {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-2].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(acmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 6548 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2336 "cfg.y" /* yacc.c:1646  */
    {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-3].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(acmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6584 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2367 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6593 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2371 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2377 "cfg.y" /* yacc.c:1646  */
    {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6610 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2380 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6616 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2381 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6622 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2382 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6628 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2383 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6634 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2385 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6640 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2387 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6646 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2389 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6652 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2391 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6658 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2393 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6664 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2394 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6670 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2395 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6678 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2398 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6689 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2404 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6695 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2405 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6702 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2407 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6713 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2413 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6719 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2414 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6726 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2416 "cfg.y" /* yacc.c:1646  */
    {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6734 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2420 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6757 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2439 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6763 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2440 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6770 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2442 "cfg.y" /* yacc.c:1646  */
    {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6798 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2465 "cfg.y" /* yacc.c:1646  */
    {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6839 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2501 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6846 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2503 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6854 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2506 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6861 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2508 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6868 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2510 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6875 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2512 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2514 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6889 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2516 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6896 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2518 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6908 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2525 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)rt_ref, (void*)(long)(yyvsp[-1].intval));
				}
#line 6920 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2532 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST, STRING_ST,
						(yyvsp[-5].action), (void*)rt_ref, (yyvsp[-1].strval));
				}
#line 6932 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2539 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6944 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2546 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-1].action), (void*)NULL);
				}
#line 6953 "cfg.tab.c" /* yacc.c:1646  */
    break;


#line 6957 "cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2553 "cfg.y" /* yacc.c:1906  */


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
